=== debian/changelog ===
dmtcp (1.2.1-2~nd09.10+1) karmic; urgency=low

  * Backported for karmic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Tue, 31 May 2011 09:05:17 -0400

dmtcp (1.2.1-2) unstable; urgency=low

  * Fixing compilation errors for gcc/g++ 4.6.
  * Fixing compilation errors related to PAGE_SIZE and PAGE_MASK macros.
  * Call "make check" towards the end of build-stamp.
  * Add python to build-deps.
  * Standards Version boosted to 3.9.2.
  * Templates removed from debian/watch.
  * Leading "./" removed from lintian-overrides.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Tue, 31 May 2011 00:17:42 -0400

dmtcp (1.2.1-1) unstable; urgency=low

  * Preparing for upstream release 1.2.1. 

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:41:11 -0500

dmtcp (1.2.0+svn937-1) unstable; urgency=low

  * Updating libdmtcpaware1.symbols to reflect the proper version.
  * Updating watch file to point to proper package name

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:10:02 -0500

dmtcp (1.2.0+svn923-1) unstable; urgency=low

  * Adding debian/libdmtcpaware1.symbols file.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Wed, 09 Mar 2011 02:03:21 -0500

dmtcp (1.2.0+svn876-1) unstable; urgency=low

  * Initial release (Closes: #610653)
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 03 Feb 2011 09:52:24 -0500
