=== debian/control ===
Source: dmtcp
Section: utils
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: Kapil Arya <kapil@ccs.neu.edu>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7), python
Standards-Version: 3.9.2
Vcs-svn: https://dmtcp.svn.sourceforge.net/svnroot/dmtcp
Vcs-browser: http://dmtcp.svn.sourceforge.net/viewvc/dmtcp/trunk
Homepage: http://dmtcp.sourceforge.net

Package: dmtcp
Architecture: i386 amd64
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Description: Checkpoint/Restart functionality for Linux processes
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package contains DMTCP binaries.

Package: dmtcp-dbg
Architecture: i386 amd64
Section: debug
Priority: extra
Depends: neurodebian-popularity-contest, dmtcp, ${shlibs:Depends}, ${misc:Depends}
Description: Debug package for dmtcp
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package contains debugging symbols for DMTCP.

Package: libdmtcpaware1
Architecture: i386 amd64
Section: libs
Depends: neurodebian-popularity-contest, dmtcp, ${shlibs:Depends}, ${misc:Depends}
Description: DMTCP programming interface
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides a programming interface to allow checkpointed
 applications to interact with dmtcp.

Package: libdmtcpaware-dev
Architecture: i386 amd64
Section: libdevel
Depends: neurodebian-popularity-contest, libdmtcpaware1 (= ${binary:Version}) , ${shlibs:Depends}, ${misc:Depends}
Description: DMTCP programming interface -- developer package
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
 checkpointing the state of an arbitrary group of programs including
 multi-threaded and distributed computations.  It operates directly on the user
 binary executable, with no Linux kernel modules or other kernel mods.
 .
 Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
 and many programming languages and shell scripting languages.  DMTCP also
 supports GNU screen sessions, including vim/cscope and emacs. With the use of
 TightVNC, it can also checkpoint and restart X-Windows applications, as long
 as they do not use extensions (e.g.: no OpenGL, no video).
 .
 This package provides libraries for developing applications that need to
 interact with dmtcp.
