=== debian/changelog ===
dmtcp (1.2.4-1~nd50+1) lenny; urgency=low

  * Backported for lenny.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 13 Feb 2012 22:38:30 -0500

dmtcp (1.2.4-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.4.
  * New binary packages libmtcp1 and libmtcp1-dev created.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Mon, 24 Jan 2012 17:00:11 -0500
