=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 Package: dmtcp
 Architecture: i386 amd64
-Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, libmtcp1, ${shlibs:Depends}, ${misc:Depends}
 Description: Checkpoint/Restart functionality for Linux processes
  DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
  checkpointing the state of an arbitrary group of programs including
@@ -22,7 +22,7 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package contains DMTCP binaries.
@@ -31,7 +31,7 @@
 Architecture: i386 amd64
 Section: debug
 Priority: extra
-Depends: neurodebian-popularity-contest, dmtcp, ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, dmtcp, ${misc:Depends}
 Description: Debug package for dmtcp
  DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
  checkpointing the state of an arbitrary group of programs including
@@ -41,10 +41,48 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package contains debugging symbols for DMTCP.
+
+Package: libmtcp1
+Architecture: i386 amd64
+Section: libs
+Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Suggests: dmtcp
+Description: DMTCP library needed for checkpointing a standalone process
+ DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
+ checkpointing the state of an arbitrary group of programs including
+ multi-threaded and distributed computations.  It operates directly on the user
+ binary executable, with no Linux kernel modules or other kernel mods.
+ .
+ Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
+ and many programming languages and shell scripting languages.  DMTCP also
+ supports GNU screen sessions, including vim/cscope and emacs. With the use of
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
+ as they do not use extensions (e.g.: no OpenGL, no video).
+ .
+ This package provides libmtcp which is needed by DMTCP to checkpoint a single
+ standalone process.
+
+Package: libmtcp-dev
+Architecture: i386 amd64
+Section: libdevel
+Depends: neurodebian-popularity-contest, libmtcp1 (= ${binary:Version}), ${misc:Depends}
+Description: Developer package for libmtcp
+ DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
+ checkpointing the state of an arbitrary group of programs including
+ multi-threaded and distributed computations.  It operates directly on the user
+ binary executable, with no Linux kernel modules or other kernel mods.
+ .
+ Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
+ and many programming languages and shell scripting languages.  DMTCP also
+ supports GNU screen sessions, including vim/cscope and emacs. With the use of
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
+ as they do not use extensions (e.g.: no OpenGL, no video).
+ .
+ This package provides header files needed for building programs with libmtcp.
 
 Package: libdmtcpaware1
 Architecture: i386 amd64
@@ -59,7 +97,7 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package provides a programming interface to allow checkpointed
@@ -68,7 +106,7 @@
 Package: libdmtcpaware-dev
 Architecture: i386 amd64
 Section: libdevel
-Depends: neurodebian-popularity-contest, libdmtcpaware1 (= ${binary:Version}) , ${shlibs:Depends}, ${misc:Depends}
+Depends: neurodebian-popularity-contest, libdmtcpaware1 (= ${binary:Version}), ${misc:Depends}
 Description: DMTCP programming interface -- developer package
  DMTCP (Distributed MultiThreaded Checkpointing) is a tool to transparently
  checkpointing the state of an arbitrary group of programs including
@@ -78,7 +116,7 @@
  Among the applications supported by DMTCP are OpenMPI, MATLAB, Python, Perl,
  and many programming languages and shell scripting languages.  DMTCP also
  supports GNU screen sessions, including vim/cscope and emacs. With the use of
- TightVNC, it can also checkpoint and restart X-Windows applications, as long
+ TightVNC, it can also checkpoint and restart X-Window applications, as long
  as they do not use extensions (e.g.: no OpenGL, no video).
  .
  This package provides libraries for developing applications that need to
